<?php
// $Id: DrupalDatabaseConnection.php,v 1.1.2.2 2009/08/24 09:43:52 wulff Exp $

/**
 * @file
 * An extension of the Auth_OpenID_DatabaseConnection which adds support for the
 * Drupal database layer.
 *
 * See DatabaseConnection.php in the PHP Openid library for documentation.
 */

/**
 * Require the base class file.
 */
require_once "Auth/OpenID/DatabaseConnection.php";

class Auth_OpenID_DrupalDatabaseConnection extends Auth_OpenID_DatabaseConnection {
  var $autoCommit = FALSE;

  /**
   * Sets auto-commit mode on this database connection.
   */
  function autoCommit($mode) {
    $this->autoCommit = $mode;
  }

  /**
   * Run an SQL query with the specified parameters, if any.
   */
  function query($sql, $params = array()) {
    $sql = str_replace(array('!', '?'), "'%s'", $sql);
    $result = db_query($sql, $params);
  }

  /**
   * Run an SQL query and return the first column of the first row
   * of the result set, if any.
   */
  function getOne($sql, $params = array()) {
    $sql = str_replace('?', "'%s'", $sql);
    $result = db_query($sql, $params);
    $row = db_fetch_array($result);
    if (!empty($row)) {
      return $row[0];
    }
  }

  /**
   * Run an SQL query and return the first row of the result set, if
   * any.
   */
  function getRow($sql, $params = array()) {
    $sql = str_replace('?', "'%s'", $sql);
    $result = db_query($sql, $params);

    return db_fetch_array($result);
  }

  /**
   * Run an SQL query with the specified parameters, if any.
   */
  function getAll($sql, $params = array()) {
    $sql = str_replace('?', "'%s'", $sql);
    $result = db_query($sql, $params);

    $rows = array();
    while ($row = db_fetch_array($result)) {
      $rows[] = $row;
    }

    return $rows;
  }

  /**
   * This dummy function is necessary because sqlstore.php insists on trying
   * to use the pear db module.
   */
  function setFetchMode($mode) {
    // do nothing
  }
}
